package com.jiuqi.grid;

import com.jiuqi.util.inifile.StreamIni;

public class LabelItem
{
    private String name;
    private String expression;
    private int position;
    private Font font;
    private int flags;
    @Deprecated
    public static final int POS_MAIN_TITLE = 1;
    @Deprecated
    public static final int POS_TOP_LEFT = 3;
    @Deprecated
    public static final int POS_TOP_CENTER = 4;
    @Deprecated
    public static final int POS_TOP_RIGHT = 5;
    @Deprecated
    public static final int POS_BOTTOM_LEFT = 9;
    @Deprecated
    public static final int POS_BOTTOM_CENTER = 10;
    @Deprecated
    public static final int POS_BOTTOM_RIGHT = 11;
    static final int[] LABEL_POS_MAPS;
    
    static {
        LABEL_POS_MAPS = new int[] { 1, 3, 4, 5, 9, 10, 11 };
    }
    
    public LabelItem() {
        this.font = new Font();
        this.flags = 0;
    }
    
    public String getName() {
        return this.name;
    }
    
    public String getExpression() {
        return this.expression;
    }
    
    public int getPosition() {
        return this.position;
    }
    
    public Font getFont() {
        return this.font;
    }
    
    public void setName(final String value) {
        this.name = value;
    }
    
    public void setExpression(final String value) {
        this.expression = value;
    }
    
    public void setPosition(final int value) {
        this.position = value;
    }
    
    public boolean getFlag(final int flag) {
        return (this.flags & flag) != 0x0;
    }
    
    public void setFlag(final int flag, final boolean value) {
        if (value) {
            this.flags |= flag;
        }
        else {
            this.flags &= ~flag;
        }
    }
    
    public void loadFromIni(final int index, final StreamIni ini) {
        final String nullstr = "";
        final String sec = "label" + Integer.toString(index);
        this.name = ini.readString(sec, "name", nullstr);
        this.expression = ini.readString(sec, "exp", nullstr);
        this.position = ini.readInteger(sec, "pos", 0);
        this.flags = ini.readInteger(sec, "flags", 0);
        this.font.setName(ini.readString(sec, "fontname", "宋体"));
        this.font.setSize(ini.readInteger(sec, "fontsize", 9));
        this.font.setColor(ini.readInteger(sec, "fontcolor", 9));
        this.font.setStylevalue(ini.readInteger(sec, "fontstyle", 0));
    }
    
    public void saveToIni(final int index, final StreamIni ini) {
        final String sec = "label" + Integer.toString(index);
        ini.writeString(sec, "name", this.name);
        ini.writeString(sec, "exp", this.expression);
        ini.writeInteger(sec, "pos", this.position);
        ini.writeInteger(sec, "flags", this.flags);
        ini.writeString(sec, "fontname", this.font.getName());
        ini.writeInteger(sec, "fontsize", this.font.getSize());
        ini.writeInteger(sec, "fontcolor", this.font.getColor());
        ini.writeInteger(sec, "fontstyle", this.font.getStylevalue());
    }
    
    @Override
    public String toString() {
        final StringBuffer result = new StringBuffer();
        result.append("name=");
        result.append(this.name);
        result.append("; exp=");
        result.append(this.expression);
        result.append("; pos=");
        result.append(this.position);
        result.append("; flags=");
        result.append(this.flags);
        result.append("; font=");
        result.append(this.name);
        return result.toString();
    }
}
